##### Load_config.py
#
#  Load config, configure Client, Server, set car controlled by joystick with Activ
#
####################################################

# python 3
import GameLogic

# Get owner
controller = GameLogic.getCurrentController()
owner = controller.owner

# get current scene
scene = GameLogic.getCurrentScene()

# get list of objects in scene
objList = scene.objects

# get object named Car and Car1
car = objList['Car']
car1 = objList['Car1']

## Load config from Dict
config = GameLogic.globalDict.get("config")

# Get elements in config list
LAN = config[0]
IP = config[1]
nbplayer = config[2]
server = config[3]

# Set prop in Monolythe for debug
owner['LAN'] = LAN
owner['IP'] = IP
owner['nbplayer'] = nbplayer
owner['server'] = server

# Set IP
GameLogic.IP = IP

# Set Server and Client with server
if server == True :
	Server = 1
	Client = 0

if server == False :
	Server = 0
	Client = 1

# Set car controlled by joystick with prop Activ in car
if Server == 1 :
	car['Activ'] = 1
	car1['Activ'] = 0
	car1['ZQSD'] = 0

if Client == 1 :
	car['Activ'] = 0
	car1['Activ'] = 1
	car1['ZQSD'] = 0

if LAN == False :
	if nbplayer == 1 :
		car['Activ'] = 1
		car1['Activ'] = 0
		car1['ZQSD'] = 0
	if nbplayer == 2 :
		car['Activ'] = 1
		car1['Activ'] = 0
		car1['ZQSD'] = 1

