##### Motor_sound.py
#
#  Sound = f(joystick,vitesse)
#
####################################################

# python 3
import GameLogic

def main():
	# get the controller
	controller = GameLogic.getCurrentController()
	owner = controller.owner

	######################### Get vitesse

	# Get vitesse in owner prop vitesse
	vitesse = owner['vitesse']

	# Vitesse is integer, set float
	vitesse = float(vitesse)

	######################### Get gas position

	# Get gas axis value
	joystickGas = controller.sensors["gasPedal"]
	axisVal = joystickGas.axisValues

	# gasPedal in the second in list
	gasPedal =  - axisVal[1]

	# gasPedal is integer ( in Z ), set float
	gasPedal = float(gasPedal)

	# Set gasPedal in range -1.0 to 1.0
	gasPedal = gasPedal / 32768

	######################### Set sound
	pitch = 1.5
	volume = 0.0

	pitch  = calculPitch(vitesse)
	volume = calculVolume(gasPedal,pitch)

	# Apply volume and pitch
	volumePitch(volume,pitch)

######################### pitch if gasPedal positive
def calculPitch(vitesse):

	### 0 to 50 km/h
	if vitesse >= 0.0 and vitesse < 50.0 :
		# x1 = 0, x2 = 50, y1 = 0.5, y2 = 1.8
		a , b = droiteAffine(0.0, 50.0, 0.5, 1.2)
		pitch = a * vitesse + b

	### 50 to 100 km/h
	if vitesse >= 50.0 and vitesse < 100.0 :
		# x1 = 50, x2 = 100, y1 = 1.2, y2 = 2.0
		a , b = droiteAffine(50.0, 100.0, 0.8, 1.4)
		pitch = a * vitesse + b

	### 100 to 150 km/h
	if vitesse >= 100.0 and vitesse < 150.0 :
		# x1 = 100, x2 = 150, y1 = 1.6, y2 = 2.2
		a , b = droiteAffine(100.0, 150.0, 1.0, 1.6)
		pitch = a * vitesse + b

	### 150 to 200 km/h
	if vitesse >= 150.0 and vitesse < 200.0 :
		# x1 = 150, x2 = 200, y1 = 2.0, y2 = 2.4
		a , b = droiteAffine(150.0, 200.0, 1.2, 1.8)
		pitch = a * vitesse + b

	### 200 to 250 km/h
	if vitesse >= 200.0 :
		# x1 = 200, x2 = 250, y1 = 2.2, y2 = 2.6
		a , b = droiteAffine(200.0, 250.0, 1.4, 2.0)
		pitch = a * vitesse + b

	return pitch

######################### volume if gasPedal positive
def calculVolume(gasPedal,pitch):
	
	# x1 = pitch mini = 0.5, x2 = pitch maxi = 2.0, y1 = volume mini = 0.2, y2 = volume maxi = 1.0
	a, b = droiteAffine(0.5, 2.4, 0.1, 0.5)

	# volume : bad equation
	volume =  a * pitch  + b

	## set mode "intuitif"
	# x1 = 0.0, x2 = 1.0, y1 = 0.2, y2 = 1.0
	a, b = droiteAffine(0.0, 1.0, 0.5, 2.0)

	gasPedal = abs(gasPedal) * a + b

	volume = volume * gasPedal
	
	## end of mode "intuitif" 
	return volume

######################### Set volume and pitch in actuator
def volumePitch(volume,pitch):

	# get the controller
	controller = GameLogic.getCurrentController()

	# Get the actuator attached to the controller named motor
	act = controller.actuators["motor"]

	# Set volume in range 0.0 to 1.0
	act.volume = volume

	# Set pitch in range 0.5 to 2.0
	act.pitch = pitch

 
######################### Return a, b in y = ax + b
# la droite passe par (x1,y1) et (x2,y2)
# x1 = a * y1 + b
# x2 = a * y2 + b
def droiteAffine(x1,x2,y1,y2):

	a = ( y2 - y1 ) / ( x2 - x1 )
	b = y1 - ( a * x1 )
	
	return a, b

######################### Main
main()
